package com.itemis.jbc.generator;

import com.itemis.jbc.binary.ClassFileAccessAPI;
import com.itemis.jbc.jbc.AALOAD;
import com.itemis.jbc.jbc.AASTORE;
import com.itemis.jbc.jbc.ACONST_NULL;
import com.itemis.jbc.jbc.ALOAD;
import com.itemis.jbc.jbc.ALOAD_0;
import com.itemis.jbc.jbc.ALOAD_1;
import com.itemis.jbc.jbc.ALOAD_2;
import com.itemis.jbc.jbc.ALOAD_3;
import com.itemis.jbc.jbc.ANEWARRAY;
import com.itemis.jbc.jbc.ARETURN;
import com.itemis.jbc.jbc.ARRAYLENGTH;
import com.itemis.jbc.jbc.ASTORE;
import com.itemis.jbc.jbc.ASTORE_0;
import com.itemis.jbc.jbc.ASTORE_1;
import com.itemis.jbc.jbc.ASTORE_2;
import com.itemis.jbc.jbc.ASTORE_3;
import com.itemis.jbc.jbc.ATHROW;
import com.itemis.jbc.jbc.AttributeInfo;
import com.itemis.jbc.jbc.Attributes;
import com.itemis.jbc.jbc.BALOAD;
import com.itemis.jbc.jbc.BASTORE;
import com.itemis.jbc.jbc.BIPUSH;
import com.itemis.jbc.jbc.CALOAD;
import com.itemis.jbc.jbc.CASTORE;
import com.itemis.jbc.jbc.CHECKCAST;
import com.itemis.jbc.jbc.ClassFile;
import com.itemis.jbc.jbc.Code;
import com.itemis.jbc.jbc.CodeTable;
import com.itemis.jbc.jbc.CodeTableEntry;
import com.itemis.jbc.jbc.ConstantClass;
import com.itemis.jbc.jbc.ConstantDouble;
import com.itemis.jbc.jbc.ConstantFieldRef;
import com.itemis.jbc.jbc.ConstantFloat;
import com.itemis.jbc.jbc.ConstantInteger;
import com.itemis.jbc.jbc.ConstantInterfaceMethodRef;
import com.itemis.jbc.jbc.ConstantInvoceDynamic;
import com.itemis.jbc.jbc.ConstantLong;
import com.itemis.jbc.jbc.ConstantMethodHandle;
import com.itemis.jbc.jbc.ConstantMethodRef;
import com.itemis.jbc.jbc.ConstantMethodType;
import com.itemis.jbc.jbc.ConstantModule;
import com.itemis.jbc.jbc.ConstantNameAndType;
import com.itemis.jbc.jbc.ConstantPackage;
import com.itemis.jbc.jbc.ConstantPool;
import com.itemis.jbc.jbc.ConstantPoolEntry;
import com.itemis.jbc.jbc.ConstantString;
import com.itemis.jbc.jbc.ConstantUtf8;
import com.itemis.jbc.jbc.ConstantValue;
import com.itemis.jbc.jbc.D2F;
import com.itemis.jbc.jbc.D2I;
import com.itemis.jbc.jbc.D2L;
import com.itemis.jbc.jbc.DADD;
import com.itemis.jbc.jbc.DALOAD;
import com.itemis.jbc.jbc.DASTORE;
import com.itemis.jbc.jbc.DCMPG;
import com.itemis.jbc.jbc.DCMPL;
import com.itemis.jbc.jbc.DCONST_0;
import com.itemis.jbc.jbc.DCONST_1;
import com.itemis.jbc.jbc.DDIV;
import com.itemis.jbc.jbc.DLOAD;
import com.itemis.jbc.jbc.DLOAD_0;
import com.itemis.jbc.jbc.DLOAD_1;
import com.itemis.jbc.jbc.DLOAD_2;
import com.itemis.jbc.jbc.DLOAD_3;
import com.itemis.jbc.jbc.DMUL;
import com.itemis.jbc.jbc.DNEG;
import com.itemis.jbc.jbc.DREM;
import com.itemis.jbc.jbc.DRETURN;
import com.itemis.jbc.jbc.DSTORE;
import com.itemis.jbc.jbc.DSTORE_0;
import com.itemis.jbc.jbc.DSTORE_1;
import com.itemis.jbc.jbc.DSTORE_2;
import com.itemis.jbc.jbc.DSTORE_3;
import com.itemis.jbc.jbc.DSUB;
import com.itemis.jbc.jbc.DUP;
import com.itemis.jbc.jbc.DUP2;
import com.itemis.jbc.jbc.DUP2_X1;
import com.itemis.jbc.jbc.DUP2_X2;
import com.itemis.jbc.jbc.DUP_X1;
import com.itemis.jbc.jbc.DUP_X2;
import com.itemis.jbc.jbc.EnclosingMethod;
import com.itemis.jbc.jbc.ExceptionTable;
import com.itemis.jbc.jbc.ExceptionTableEntry;
import com.itemis.jbc.jbc.Exceptions;
import com.itemis.jbc.jbc.Exports;
import com.itemis.jbc.jbc.ExportsTo;
import com.itemis.jbc.jbc.F2D;
import com.itemis.jbc.jbc.F2I;
import com.itemis.jbc.jbc.F2L;
import com.itemis.jbc.jbc.FADD;
import com.itemis.jbc.jbc.FALOAD;
import com.itemis.jbc.jbc.FASTORE;
import com.itemis.jbc.jbc.FCMPG;
import com.itemis.jbc.jbc.FCMPL;
import com.itemis.jbc.jbc.FCONST_0;
import com.itemis.jbc.jbc.FCONST_1;
import com.itemis.jbc.jbc.FCONST_2;
import com.itemis.jbc.jbc.FDIV;
import com.itemis.jbc.jbc.FLOAD;
import com.itemis.jbc.jbc.FLOAD_0;
import com.itemis.jbc.jbc.FLOAD_1;
import com.itemis.jbc.jbc.FLOAD_2;
import com.itemis.jbc.jbc.FLOAD_3;
import com.itemis.jbc.jbc.FMUL;
import com.itemis.jbc.jbc.FNEG;
import com.itemis.jbc.jbc.FREM;
import com.itemis.jbc.jbc.FRETURN;
import com.itemis.jbc.jbc.FSTORE;
import com.itemis.jbc.jbc.FSTORE_0;
import com.itemis.jbc.jbc.FSTORE_1;
import com.itemis.jbc.jbc.FSTORE_2;
import com.itemis.jbc.jbc.FSTORE_3;
import com.itemis.jbc.jbc.FSUB;
import com.itemis.jbc.jbc.FieldInfo;
import com.itemis.jbc.jbc.Fields;
import com.itemis.jbc.jbc.GETFIELD;
import com.itemis.jbc.jbc.GETSTATIC;
import com.itemis.jbc.jbc.GOTO;
import com.itemis.jbc.jbc.GOTO_W;
import com.itemis.jbc.jbc.I2B;
import com.itemis.jbc.jbc.I2C;
import com.itemis.jbc.jbc.I2D;
import com.itemis.jbc.jbc.I2F;
import com.itemis.jbc.jbc.I2L;
import com.itemis.jbc.jbc.I2S;
import com.itemis.jbc.jbc.IADD;
import com.itemis.jbc.jbc.IALOAD;
import com.itemis.jbc.jbc.IAND;
import com.itemis.jbc.jbc.IASTORE;
import com.itemis.jbc.jbc.ICONST_0;
import com.itemis.jbc.jbc.ICONST_1;
import com.itemis.jbc.jbc.ICONST_2;
import com.itemis.jbc.jbc.ICONST_3;
import com.itemis.jbc.jbc.ICONST_4;
import com.itemis.jbc.jbc.ICONST_5;
import com.itemis.jbc.jbc.ICONST_ML;
import com.itemis.jbc.jbc.IDIV;
import com.itemis.jbc.jbc.IFEQ;
import com.itemis.jbc.jbc.IFGE;
import com.itemis.jbc.jbc.IFGT;
import com.itemis.jbc.jbc.IFLE;
import com.itemis.jbc.jbc.IFLT;
import com.itemis.jbc.jbc.IFNE;
import com.itemis.jbc.jbc.IFNONNULL;
import com.itemis.jbc.jbc.IFNULL;
import com.itemis.jbc.jbc.IF_ACMPEQ;
import com.itemis.jbc.jbc.IF_ACMPNE;
import com.itemis.jbc.jbc.IF_ICMPEQ;
import com.itemis.jbc.jbc.IF_ICMPGE;
import com.itemis.jbc.jbc.IF_ICMPGT;
import com.itemis.jbc.jbc.IF_ICMPLE;
import com.itemis.jbc.jbc.IF_ICMPLT;
import com.itemis.jbc.jbc.IF_ICMPNE;
import com.itemis.jbc.jbc.IINC;
import com.itemis.jbc.jbc.ILOAD;
import com.itemis.jbc.jbc.ILOAD_0;
import com.itemis.jbc.jbc.ILOAD_1;
import com.itemis.jbc.jbc.ILOAD_2;
import com.itemis.jbc.jbc.ILOAD_3;
import com.itemis.jbc.jbc.IMUL;
import com.itemis.jbc.jbc.INEG;
import com.itemis.jbc.jbc.INSTANCEOF;
import com.itemis.jbc.jbc.INVOKEDYNAMIC;
import com.itemis.jbc.jbc.INVOKEINTERFACE;
import com.itemis.jbc.jbc.INVOKESPECIAL;
import com.itemis.jbc.jbc.INVOKESTATIC;
import com.itemis.jbc.jbc.INVOKEVIRTUAL;
import com.itemis.jbc.jbc.IOR;
import com.itemis.jbc.jbc.IREM;
import com.itemis.jbc.jbc.IRETURN;
import com.itemis.jbc.jbc.ISHL;
import com.itemis.jbc.jbc.ISHR;
import com.itemis.jbc.jbc.ISTORE;
import com.itemis.jbc.jbc.ISTORE_0;
import com.itemis.jbc.jbc.ISTORE_1;
import com.itemis.jbc.jbc.ISTORE_2;
import com.itemis.jbc.jbc.ISTORE_3;
import com.itemis.jbc.jbc.ISUB;
import com.itemis.jbc.jbc.IUSHR;
import com.itemis.jbc.jbc.IXOR;
import com.itemis.jbc.jbc.InnerClass;
import com.itemis.jbc.jbc.InnerClasses;
import com.itemis.jbc.jbc.Interface;
import com.itemis.jbc.jbc.Interfaces;
import com.itemis.jbc.jbc.JSR;
import com.itemis.jbc.jbc.JSR_W;
import com.itemis.jbc.jbc.JumpOffset;
import com.itemis.jbc.jbc.L2D;
import com.itemis.jbc.jbc.L2F;
import com.itemis.jbc.jbc.L2I;
import com.itemis.jbc.jbc.LADD;
import com.itemis.jbc.jbc.LALOAD;
import com.itemis.jbc.jbc.LAND;
import com.itemis.jbc.jbc.LASTORE;
import com.itemis.jbc.jbc.LCMP;
import com.itemis.jbc.jbc.LCONST_0;
import com.itemis.jbc.jbc.LCONST_1;
import com.itemis.jbc.jbc.LDC;
import com.itemis.jbc.jbc.LDC2_W;
import com.itemis.jbc.jbc.LDC_W;
import com.itemis.jbc.jbc.LDIV;
import com.itemis.jbc.jbc.LLOAD;
import com.itemis.jbc.jbc.LLOAD_0;
import com.itemis.jbc.jbc.LLOAD_1;
import com.itemis.jbc.jbc.LLOAD_2;
import com.itemis.jbc.jbc.LLOAD_3;
import com.itemis.jbc.jbc.LMUL;
import com.itemis.jbc.jbc.LNEG;
import com.itemis.jbc.jbc.LOOKUPSWITCH;
import com.itemis.jbc.jbc.LOR;
import com.itemis.jbc.jbc.LREM;
import com.itemis.jbc.jbc.LRETURN;
import com.itemis.jbc.jbc.LSHL;
import com.itemis.jbc.jbc.LSHR;
import com.itemis.jbc.jbc.LSTORE;
import com.itemis.jbc.jbc.LSTORE_0;
import com.itemis.jbc.jbc.LSTORE_1;
import com.itemis.jbc.jbc.LSTORE_2;
import com.itemis.jbc.jbc.LSTORE_3;
import com.itemis.jbc.jbc.LSUB;
import com.itemis.jbc.jbc.LUSHR;
import com.itemis.jbc.jbc.LXOR;
import com.itemis.jbc.jbc.LineNumber;
import com.itemis.jbc.jbc.LineNumberTable;
import com.itemis.jbc.jbc.LocalVariable;
import com.itemis.jbc.jbc.LocalVariableTable;
import com.itemis.jbc.jbc.MONITORENTER;
import com.itemis.jbc.jbc.MONITOREXIT;
import com.itemis.jbc.jbc.MULTIANEWARRAY;
import com.itemis.jbc.jbc.MatchOffsetPair;
import com.itemis.jbc.jbc.MethodInfo;
import com.itemis.jbc.jbc.Methods;
import com.itemis.jbc.jbc.Module;
import com.itemis.jbc.jbc.NEW;
import com.itemis.jbc.jbc.NEWARRAY;
import com.itemis.jbc.jbc.NOP;
import com.itemis.jbc.jbc.Opens;
import com.itemis.jbc.jbc.OpensTo;
import com.itemis.jbc.jbc.POP;
import com.itemis.jbc.jbc.POP2;
import com.itemis.jbc.jbc.PUTFIELD;
import com.itemis.jbc.jbc.PUTSTATIC;
import com.itemis.jbc.jbc.Provides;
import com.itemis.jbc.jbc.ProvidesWith;
import com.itemis.jbc.jbc.RET;
import com.itemis.jbc.jbc.RETURN;
import com.itemis.jbc.jbc.Requires;
import com.itemis.jbc.jbc.SALOAD;
import com.itemis.jbc.jbc.SASTORE;
import com.itemis.jbc.jbc.SIPUSH;
import com.itemis.jbc.jbc.SWAP;
import com.itemis.jbc.jbc.SourceFile;
import com.itemis.jbc.jbc.TABLESWITCH;
import com.itemis.jbc.jbc.U1;
import com.itemis.jbc.jbc.U2;
import com.itemis.jbc.jbc.Unknown;
import com.itemis.jbc.jbc.Uses;
import com.itemis.jbc.jbc.WIDE;
import java.util.Arrays;
import org.apache.commons.lang3.StringEscapeUtils;
import org.eclipse.emf.common.util.EList;
import org.eclipse.xtend2.lib.StringConcatenation;

@SuppressWarnings("all")
public class JBCCodeTemplates {
  public static String code(final ClassFile classFile) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("ClassFile {");
    _builder.newLine();
    _builder.append("\t");
    String _value = classFile.getMagic().getValue();
    _builder.append(_value, "\t");
    _builder.append(" ");
    String _value_1 = classFile.getMinorVersion().getValue();
    _builder.append(_value_1, "\t");
    _builder.append(" ");
    String _value_2 = classFile.getMajorVersion().getValue();
    _builder.append(_value_2, "\t");
    _builder.append(" ");
    String _value_3 = classFile.getConstantPoolCount().getValue();
    _builder.append(_value_3, "\t");
    _builder.append(" ");
    String _code = JBCCodeTemplates.code(classFile.getConstantPool());
    _builder.append(_code, "\t");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    String _value_4 = classFile.getAccessFlags().getValue();
    _builder.append(_value_4, "\t");
    _builder.append(" ");
    String _u2Value = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(classFile.getThisClass()));
    _builder.append(_u2Value, "\t");
    _builder.append(" ");
    String _u2Value_1 = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(classFile.getSuperClass()));
    _builder.append(_u2Value_1, "\t");
    _builder.append(" ");
    String _value_5 = classFile.getInterfaceCount().getValue();
    _builder.append(_value_5, "\t");
    _builder.append(" ");
    String _code_1 = JBCCodeTemplates.code(classFile.getInterfaces());
    _builder.append(_code_1, "\t");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    String _value_6 = classFile.getFieldsCount().getValue();
    _builder.append(_value_6, "\t");
    _builder.append(" ");
    String _code_2 = JBCCodeTemplates.code(classFile.getFields());
    _builder.append(_code_2, "\t");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    String _value_7 = classFile.getMethodsCount().getValue();
    _builder.append(_value_7, "\t");
    _builder.append(" ");
    String _code_3 = JBCCodeTemplates.code(classFile.getMethods());
    _builder.append(_code_3, "\t");
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    String _value_8 = classFile.getAttributesCount().getValue();
    _builder.append(_value_8, "\t");
    _builder.append(" ");
    String _code_4 = JBCCodeTemplates.code(classFile.getAttributes());
    _builder.append(_code_4, "\t");
    _builder.newLineIfNotEmpty();
    _builder.append("}");
    _builder.newLine();
    return _builder.toString();
  }
  
  public static String code(final ConstantPool constantPool) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("ConstantPool {");
    _builder.newLine();
    {
      EList<ConstantPoolEntry> _cpInfo = constantPool.getCpInfo();
      for(final ConstantPoolEntry constant : _cpInfo) {
        _builder.append("\t");
        String _constantCode = JBCCodeTemplates.constantCode(constant);
        _builder.append(_constantCode, "\t");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.append("}");
    _builder.newLine();
    return _builder.toString();
  }
  
  protected static String _constantCode(final ConstantUtf8 constant) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("utf8 ");
    String _value = constant.getTag().getValue();
    _builder.append(_value);
    _builder.append(" \"");
    String _escapeJava = StringEscapeUtils.escapeJava(constant.getContent().getValue());
    _builder.append(_escapeJava);
    _builder.append("\"");
    return _builder.toString();
  }
  
  protected static String _constantCode(final ConstantInteger constant) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("integer ");
    String _value = constant.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _value_1 = constant.getBytes().getValue();
    _builder.append(_value_1);
    return _builder.toString();
  }
  
  protected static String _constantCode(final ConstantFloat constant) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("float ");
    String _value = constant.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _value_1 = constant.getBytes().getValue();
    _builder.append(_value_1);
    return _builder.toString();
  }
  
  protected static String _constantCode(final ConstantLong constant) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("long ");
    String _value = constant.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _value_1 = constant.getHighBytes().getValue();
    _builder.append(_value_1);
    _builder.append(" ");
    String _value_2 = constant.getLowBytes().getValue();
    _builder.append(_value_2);
    return _builder.toString();
  }
  
  protected static String _constantCode(final ConstantDouble constant) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("double ");
    String _value = constant.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _value_1 = constant.getHighBytes().getValue();
    _builder.append(_value_1);
    _builder.append(" ");
    String _value_2 = constant.getLowBytes().getValue();
    _builder.append(_value_2);
    return _builder.toString();
  }
  
  protected static String _constantCode(final ConstantClass constant) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("class ");
    String _value = constant.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    ConstantUtf8 _nameIndex = constant.getNameIndex();
    int _index = 0;
    if (_nameIndex!=null) {
      _index=ClassFileAccessAPI.index(_nameIndex);
    }
    String _u2Value = ClassFileAccessAPI.u2Value(_index);
    _builder.append(_u2Value);
    return _builder.toString();
  }
  
  protected static String _constantCode(final ConstantString constant) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("string ");
    String _value = constant.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    ConstantUtf8 _stringIndex = constant.getStringIndex();
    int _index = 0;
    if (_stringIndex!=null) {
      _index=ClassFileAccessAPI.index(_stringIndex);
    }
    String _u2Value = ClassFileAccessAPI.u2Value(_index);
    _builder.append(_u2Value);
    return _builder.toString();
  }
  
  protected static String _constantCode(final ConstantFieldRef constant) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("fieldRef ");
    String _value = constant.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    ConstantClass _classIndex = constant.getClassIndex();
    int _index = 0;
    if (_classIndex!=null) {
      _index=ClassFileAccessAPI.index(_classIndex);
    }
    String _u2Value = ClassFileAccessAPI.u2Value(_index);
    _builder.append(_u2Value);
    _builder.append(" ");
    ConstantNameAndType _nameAndTypeIndex = constant.getNameAndTypeIndex();
    int _index_1 = 0;
    if (_nameAndTypeIndex!=null) {
      _index_1=ClassFileAccessAPI.index(_nameAndTypeIndex);
    }
    String _u2Value_1 = ClassFileAccessAPI.u2Value(_index_1);
    _builder.append(_u2Value_1);
    return _builder.toString();
  }
  
  protected static String _constantCode(final ConstantMethodRef constant) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("methodRef ");
    String _value = constant.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    ConstantClass _classIndex = constant.getClassIndex();
    int _index = 0;
    if (_classIndex!=null) {
      _index=ClassFileAccessAPI.index(_classIndex);
    }
    String _u2Value = ClassFileAccessAPI.u2Value(_index);
    _builder.append(_u2Value);
    _builder.append(" ");
    ConstantNameAndType _nameAndTypeIndex = constant.getNameAndTypeIndex();
    int _index_1 = 0;
    if (_nameAndTypeIndex!=null) {
      _index_1=ClassFileAccessAPI.index(_nameAndTypeIndex);
    }
    String _u2Value_1 = ClassFileAccessAPI.u2Value(_index_1);
    _builder.append(_u2Value_1);
    return _builder.toString();
  }
  
  protected static String _constantCode(final ConstantInterfaceMethodRef constant) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("interfaceMethodRef ");
    String _value = constant.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    ConstantClass _classIndex = constant.getClassIndex();
    int _index = 0;
    if (_classIndex!=null) {
      _index=ClassFileAccessAPI.index(_classIndex);
    }
    String _u2Value = ClassFileAccessAPI.u2Value(_index);
    _builder.append(_u2Value);
    _builder.append(" ");
    ConstantNameAndType _nameAndTypeIndex = constant.getNameAndTypeIndex();
    int _index_1 = 0;
    if (_nameAndTypeIndex!=null) {
      _index_1=ClassFileAccessAPI.index(_nameAndTypeIndex);
    }
    String _u2Value_1 = ClassFileAccessAPI.u2Value(_index_1);
    _builder.append(_u2Value_1);
    return _builder.toString();
  }
  
  protected static String _constantCode(final ConstantNameAndType constant) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("nameAndType ");
    String _value = constant.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    ConstantUtf8 _nameIndex = constant.getNameIndex();
    int _index = 0;
    if (_nameIndex!=null) {
      _index=ClassFileAccessAPI.index(_nameIndex);
    }
    String _u2Value = ClassFileAccessAPI.u2Value(_index);
    _builder.append(_u2Value);
    _builder.append(" ");
    ConstantUtf8 _descriptorIndex = constant.getDescriptorIndex();
    int _index_1 = 0;
    if (_descriptorIndex!=null) {
      _index_1=ClassFileAccessAPI.index(_descriptorIndex);
    }
    String _u2Value_1 = ClassFileAccessAPI.u2Value(_index_1);
    _builder.append(_u2Value_1);
    return _builder.toString();
  }
  
  protected static String _constantCode(final ConstantMethodHandle constant) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("methodHandle ");
    String _value = constant.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _value_1 = constant.getReferenceKind().getValue();
    _builder.append(_value_1);
    _builder.append(" ");
    ConstantPoolEntry _referenceIndex = constant.getReferenceIndex();
    int _index = 0;
    if (_referenceIndex!=null) {
      _index=ClassFileAccessAPI.index(_referenceIndex);
    }
    String _u2Value = ClassFileAccessAPI.u2Value(_index);
    _builder.append(_u2Value);
    return _builder.toString();
  }
  
  protected static String _constantCode(final ConstantMethodType constant) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("methodType ");
    String _value = constant.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    ConstantUtf8 _descriptorIndex = constant.getDescriptorIndex();
    int _index = 0;
    if (_descriptorIndex!=null) {
      _index=ClassFileAccessAPI.index(_descriptorIndex);
    }
    String _u2Value = ClassFileAccessAPI.u2Value(_index);
    _builder.append(_u2Value);
    return _builder.toString();
  }
  
  protected static String _constantCode(final ConstantInvoceDynamic constant) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("invoceDynamic ");
    String _value = constant.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _value_1 = constant.getBootstrapMethodAttrIndex().getValue();
    _builder.append(_value_1);
    _builder.append(" ");
    ConstantNameAndType _nameAndTypeIndex = constant.getNameAndTypeIndex();
    int _index = 0;
    if (_nameAndTypeIndex!=null) {
      _index=ClassFileAccessAPI.index(_nameAndTypeIndex);
    }
    String _u2Value = ClassFileAccessAPI.u2Value(_index);
    _builder.append(_u2Value);
    return _builder.toString();
  }
  
  protected static String _constantCode(final ConstantModule constant) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("module ");
    String _value = constant.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    ConstantUtf8 _nameIndex = constant.getNameIndex();
    int _index = 0;
    if (_nameIndex!=null) {
      _index=ClassFileAccessAPI.index(_nameIndex);
    }
    String _u2Value = ClassFileAccessAPI.u2Value(_index);
    _builder.append(_u2Value);
    return _builder.toString();
  }
  
  protected static String _constantCode(final ConstantPackage constant) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("package ");
    String _value = constant.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    ConstantUtf8 _nameIndex = constant.getNameIndex();
    int _index = 0;
    if (_nameIndex!=null) {
      _index=ClassFileAccessAPI.index(_nameIndex);
    }
    String _u2Value = ClassFileAccessAPI.u2Value(_index);
    _builder.append(_u2Value);
    return _builder.toString();
  }
  
  public static String code(final Interfaces interfaces) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("Interfaces {");
    _builder.newLine();
    {
      EList<Interface> _interfaceInfo = interfaces.getInterfaceInfo();
      for(final Interface i : _interfaceInfo) {
        _builder.append("\t");
        String _u2Value = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(i.getInfo()));
        _builder.append(_u2Value, "\t");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.append("}");
    _builder.newLine();
    return _builder.toString();
  }
  
  public static String code(final Fields fields) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("Fields {");
    _builder.newLine();
    {
      EList<FieldInfo> _fieldInfo = fields.getFieldInfo();
      for(final FieldInfo field : _fieldInfo) {
        _builder.append("\t");
        String _code = JBCCodeTemplates.code(field);
        _builder.append(_code, "\t");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.append("}");
    _builder.newLine();
    return _builder.toString();
  }
  
  public static String code(final FieldInfo field) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("field ");
    String _value = field.getAccessFlags().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _u2Value = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(field.getNameIndex()));
    _builder.append(_u2Value);
    _builder.append(" ");
    String _u2Value_1 = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(field.getDescriptorIndex()));
    _builder.append(_u2Value_1);
    _builder.append(" ");
    String _value_1 = field.getAttributesCount().getValue();
    _builder.append(_value_1);
    _builder.append(" ");
    String _code = JBCCodeTemplates.code(field.getAttributes());
    _builder.append(_code);
    return _builder.toString();
  }
  
  public static String code(final Methods methods) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("Methods {");
    _builder.newLine();
    {
      EList<MethodInfo> _methodsInfo = methods.getMethodsInfo();
      for(final MethodInfo method : _methodsInfo) {
        _builder.append("\t");
        String _code = JBCCodeTemplates.code(method);
        _builder.append(_code, "\t");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.append("}");
    _builder.newLine();
    return _builder.toString();
  }
  
  public static String code(final MethodInfo method) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("method ");
    String _value = method.getAccessFlags().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _u2Value = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(method.getNameIndex()));
    _builder.append(_u2Value);
    _builder.append(" ");
    String _u2Value_1 = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(method.getDescriptorIndex()));
    _builder.append(_u2Value_1);
    _builder.append(" ");
    String _value_1 = method.getAttributesCount().getValue();
    _builder.append(_value_1);
    _builder.append(" ");
    String _code = JBCCodeTemplates.code(method.getAttributes());
    _builder.append(_code);
    return _builder.toString();
  }
  
  public static String code(final Attributes attributes) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("Attributes {");
    _builder.newLine();
    {
      EList<AttributeInfo> _attributeInfo = attributes.getAttributeInfo();
      for(final AttributeInfo attribute : _attributeInfo) {
        _builder.append("\t");
        String _attributeCode = JBCCodeTemplates.attributeCode(attribute);
        _builder.append(_attributeCode, "\t");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.append("}");
    _builder.newLine();
    return _builder.toString();
  }
  
  protected static String _attributeCode(final Unknown attribute) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("unknown ");
    String _u2Value = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(attribute.getAttributeNameIndex()));
    _builder.append(_u2Value);
    _builder.append(" ");
    String _value = attribute.getAttributeLength().getValue();
    _builder.append(_value);
    _builder.append(" Info { ");
    String _code = JBCCodeTemplates.code(attribute.getInfo());
    _builder.append(_code);
    _builder.append("}");
    _builder.newLineIfNotEmpty();
    return _builder.toString();
  }
  
  protected static String _attributeCode(final ConstantValue attribute) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("constantValue ");
    String _u2Value = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(attribute.getAttributeNameIndex()));
    _builder.append(_u2Value);
    _builder.append(" ");
    String _value = attribute.getAttributeLength().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _u2Value_1 = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(attribute.getConstantValueIndex()));
    _builder.append(_u2Value_1);
    return _builder.toString();
  }
  
  protected static String _attributeCode(final Code attribute) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("code ");
    String _u2Value = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(attribute.getAttributeNameIndex()));
    _builder.append(_u2Value);
    _builder.append(" ");
    String _value = attribute.getAttributeLength().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _value_1 = attribute.getMaxStack().getValue();
    _builder.append(_value_1);
    _builder.append(" ");
    String _value_2 = attribute.getMaxLocals().getValue();
    _builder.append(_value_2);
    _builder.append(" ");
    String _value_3 = attribute.getCodeLength().getValue();
    _builder.append(_value_3);
    _builder.append(" ");
    String _code = JBCCodeTemplates.code(attribute.getCodeTable());
    _builder.append(_code);
    _builder.append(" ");
    String _value_4 = attribute.getExceptionTableLength().getValue();
    _builder.append(_value_4);
    _builder.append(" ");
    String _code_1 = JBCCodeTemplates.code(attribute.getExceptionTable());
    _builder.append(_code_1);
    _builder.append(" ");
    String _value_5 = attribute.getAttributesCount().getValue();
    _builder.append(_value_5);
    _builder.append(" ");
    String _code_2 = JBCCodeTemplates.code(attribute.getAttributes());
    _builder.append(_code_2);
    _builder.newLineIfNotEmpty();
    return _builder.toString();
  }
  
  protected static String _attributeCode(final SourceFile attribute) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("sourceFile ");
    String _u2Value = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(attribute.getAttributeNameIndex()));
    _builder.append(_u2Value);
    _builder.append(" ");
    String _value = attribute.getAttributeLength().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _u2Value_1 = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(attribute.getSourceFileIndex()));
    _builder.append(_u2Value_1);
    return _builder.toString();
  }
  
  protected static String _attributeCode(final LineNumberTable attribute) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("lineNumberTable ");
    String _u2Value = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(attribute.getAttributeNameIndex()));
    _builder.append(_u2Value);
    _builder.append(" ");
    String _value = attribute.getAttributeLength().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _value_1 = attribute.getLineNumberTableLength().getValue();
    _builder.append(_value_1);
    _builder.append(" Table {");
    _builder.newLineIfNotEmpty();
    {
      EList<LineNumber> _lineNumbers = attribute.getLineNumbers();
      for(final LineNumber line : _lineNumbers) {
        _builder.append("\t");
        _builder.append("lineNumber ");
        String _u2Value_1 = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.offset(line.getStartPc()));
        _builder.append(_u2Value_1, "\t");
        _builder.append(" ");
        String _value_2 = line.getLineNumber().getValue();
        _builder.append(_value_2, "\t");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.append("}");
    return _builder.toString();
  }
  
  protected static String _attributeCode(final LocalVariableTable attribute) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("localVariableTable ");
    String _u2Value = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(attribute.getAttributeNameIndex()));
    _builder.append(_u2Value);
    _builder.append(" ");
    String _value = attribute.getAttributeLength().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _value_1 = attribute.getLocalVariableTableLength().getValue();
    _builder.append(_value_1);
    _builder.append(" Table {");
    _builder.newLineIfNotEmpty();
    {
      EList<LocalVariable> _localVariables = attribute.getLocalVariables();
      for(final LocalVariable variable : _localVariables) {
        _builder.append("\t");
        _builder.append("localVariable ");
        String _u2Value_1 = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.offset(variable.getStartPc()));
        _builder.append(_u2Value_1, "\t");
        _builder.append(" ");
        String _value_2 = variable.getLength().getValue();
        _builder.append(_value_2, "\t");
        _builder.append(" ");
        String _u2Value_2 = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(variable.getNameIndex()));
        _builder.append(_u2Value_2, "\t");
        _builder.append(" ");
        String _u2Value_3 = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(variable.getDescriptorIndex()));
        _builder.append(_u2Value_3, "\t");
        _builder.append(" ");
        String _value_3 = variable.getIndex().getValue();
        _builder.append(_value_3, "\t");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.append("}");
    return _builder.toString();
  }
  
  protected static String _attributeCode(final Exceptions attribute) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("exceptions ");
    String _u2Value = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(attribute.getAttributeNameIndex()));
    _builder.append(_u2Value);
    _builder.append(" ");
    String _value = attribute.getAttributeLength().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _value_1 = attribute.getNumberOfExceptions().getValue();
    _builder.append(_value_1);
    _builder.append(" Table {");
    _builder.newLineIfNotEmpty();
    {
      EList<com.itemis.jbc.jbc.Exception> _exception = attribute.getException();
      for(final com.itemis.jbc.jbc.Exception exception : _exception) {
        _builder.append("\t");
        _builder.append("exception ");
        String _u2Value_1 = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(exception.getIndex()));
        _builder.append(_u2Value_1, "\t");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.append("}");
    return _builder.toString();
  }
  
  protected static String _attributeCode(final InnerClasses attribute) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("innerClasses ");
    String _u2Value = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(attribute.getAttributeNameIndex()));
    _builder.append(_u2Value);
    _builder.append(" ");
    String _value = attribute.getAttributeLength().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _value_1 = attribute.getNumberOfClasses().getValue();
    _builder.append(_value_1);
    _builder.append(" Table {");
    _builder.newLineIfNotEmpty();
    {
      EList<InnerClass> _innerClasses = attribute.getInnerClasses();
      for(final InnerClass innerClass : _innerClasses) {
        _builder.append("\t");
        _builder.append("innerClass ");
        String _u2Value_1 = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(innerClass.getInnerClassInfoIndex()));
        _builder.append(_u2Value_1, "\t");
        _builder.append(" ");
        String _u2Value_2 = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(innerClass.getOuterClassInfoIndex()));
        _builder.append(_u2Value_2, "\t");
        _builder.append(" ");
        String _u2Value_3 = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(innerClass.getInnerNameIndex()));
        _builder.append(_u2Value_3, "\t");
        _builder.append(" ");
        String _value_2 = innerClass.getInnerClassAccessFlags().getValue();
        _builder.append(_value_2, "\t");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.append("}");
    return _builder.toString();
  }
  
  protected static String _attributeCode(final EnclosingMethod attribute) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("enclosingMethod ");
    String _u2Value = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(attribute.getAttributeNameIndex()));
    _builder.append(_u2Value);
    _builder.append(" ");
    String _value = attribute.getAttributeLength().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _u2Value_1 = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(attribute.getClassIndex()));
    _builder.append(_u2Value_1);
    _builder.append(" ");
    String _u2Value_2 = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(attribute.getMethodIndex()));
    _builder.append(_u2Value_2);
    return _builder.toString();
  }
  
  protected static String _attributeCode(final Module attribute) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("module ");
    String _u2Value = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(attribute.getAttributeNameIndex()));
    _builder.append(_u2Value);
    _builder.append(" ");
    String _value = attribute.getAttributeLength().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _u2Value_1 = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(attribute.getModuleNameIndex()));
    _builder.append(_u2Value_1);
    _builder.append(" ");
    String _value_1 = attribute.getModuleFlags().getValue();
    _builder.append(_value_1);
    _builder.append(" ");
    String _u2Value_2 = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(attribute.getModuleVersionIndex()));
    _builder.append(_u2Value_2);
    _builder.newLineIfNotEmpty();
    _builder.append("\t");
    String _value_2 = attribute.getRequiresCount().getValue();
    _builder.append(_value_2, "\t");
    _builder.append(" Requires {");
    _builder.newLineIfNotEmpty();
    {
      EList<Requires> _requires = attribute.getRequires();
      for(final Requires require : _requires) {
        _builder.append("\t\t");
        _builder.append("require ");
        String _u2Value_3 = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(require.getRequiresIndex()));
        _builder.append(_u2Value_3, "\t\t");
        _builder.append(" ");
        String _value_3 = require.getRequiresFlags().getValue();
        _builder.append(_value_3, "\t\t");
        _builder.append(" ");
        String _u2Value_4 = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(require.getRequiresVersionIndex()));
        _builder.append(_u2Value_4, "\t\t");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.append("\t");
    _builder.append("}");
    _builder.newLine();
    _builder.append("\t");
    String _value_4 = attribute.getExportsCount().getValue();
    _builder.append(_value_4, "\t");
    _builder.append(" Exports {");
    _builder.newLineIfNotEmpty();
    {
      EList<Exports> _exports = attribute.getExports();
      for(final Exports export : _exports) {
        _builder.append("\t\t");
        _builder.append("export ");
        String _u2Value_5 = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(export.getExportsIndex()));
        _builder.append(_u2Value_5, "\t\t");
        _builder.append(" ");
        String _value_5 = export.getExportsFlags().getValue();
        _builder.append(_value_5, "\t\t");
        _builder.append(" ");
        String _value_6 = export.getExportsToCount().getValue();
        _builder.append(_value_6, "\t\t");
        _builder.append(" To {");
        {
          EList<ExportsTo> _exportsTo = export.getExportsTo();
          for(final ExportsTo exportTo : _exportsTo) {
            _builder.append(" ");
            String _u2Value_6 = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(exportTo.getExportsToIndex()));
            _builder.append(_u2Value_6, "\t\t");
            _builder.append(" ");
          }
        }
        _builder.append("}");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.append("\t");
    _builder.append("}");
    _builder.newLine();
    _builder.append("\t");
    String _value_7 = attribute.getOpensCount().getValue();
    _builder.append(_value_7, "\t");
    _builder.append(" Opens {");
    _builder.newLineIfNotEmpty();
    {
      EList<Opens> _opens = attribute.getOpens();
      for(final Opens open : _opens) {
        _builder.append("\t\t");
        _builder.append("open ");
        String _u2Value_7 = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(open.getOpensIndex()));
        _builder.append(_u2Value_7, "\t\t");
        _builder.append(" ");
        String _value_8 = open.getOpensFlags().getValue();
        _builder.append(_value_8, "\t\t");
        _builder.append(" ");
        String _value_9 = open.getOpensToCount().getValue();
        _builder.append(_value_9, "\t\t");
        _builder.append(" To {");
        {
          EList<OpensTo> _opensTo = open.getOpensTo();
          for(final OpensTo opensTo : _opensTo) {
            _builder.append(" ");
            String _u2Value_8 = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(opensTo.getOpensToIndex()));
            _builder.append(_u2Value_8, "\t\t");
            _builder.append(" ");
          }
        }
        _builder.append("}");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.append("\t");
    _builder.append("}");
    _builder.newLine();
    _builder.append("\t");
    String _value_10 = attribute.getUsesCount().getValue();
    _builder.append(_value_10, "\t");
    _builder.append(" Uses {");
    _builder.newLineIfNotEmpty();
    {
      EList<Uses> _uses = attribute.getUses();
      for(final Uses use : _uses) {
        _builder.append("\t\t");
        _builder.append("use ");
        String _u2Value_9 = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(use.getUsesIndex()));
        _builder.append(_u2Value_9, "\t\t");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.append("\t");
    _builder.append("}");
    _builder.newLine();
    _builder.append("\t");
    String _value_11 = attribute.getProvidesCount().getValue();
    _builder.append(_value_11, "\t");
    _builder.append(" Provides {");
    _builder.newLineIfNotEmpty();
    {
      EList<Provides> _provides = attribute.getProvides();
      for(final Provides provide : _provides) {
        _builder.append("\t\t");
        _builder.append("provide ");
        String _u2Value_10 = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(provide.getProvidesIndex()));
        _builder.append(_u2Value_10, "\t\t");
        _builder.append(" ");
        String _value_12 = provide.getProvidesWithCount().getValue();
        _builder.append(_value_12, "\t\t");
        _builder.append(" With {");
        {
          EList<ProvidesWith> _providesWith = provide.getProvidesWith();
          for(final ProvidesWith providesWith : _providesWith) {
            _builder.append(" ");
            String _u2Value_11 = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(providesWith.getProvidesWithIndex()));
            _builder.append(_u2Value_11, "\t\t");
            _builder.append(" ");
          }
        }
        _builder.append("}");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.append("\t");
    _builder.append("}");
    _builder.newLine();
    return _builder.toString();
  }
  
  private static String code(final CodeTable codeTable) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("Code {");
    _builder.newLine();
    {
      EList<CodeTableEntry> _instruction = codeTable.getInstruction();
      for(final CodeTableEntry instruction : _instruction) {
        _builder.append("\t");
        String _instructionCode = JBCCodeTemplates.instructionCode(instruction);
        _builder.append(_instructionCode, "\t");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.append("}");
    return _builder.toString();
  }
  
  private static String _instructionCode(final AALOAD it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("aaload ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final AASTORE it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("aastore ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final ACONST_NULL it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("aconst_null ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final ALOAD it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("aload ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _value_1 = it.getIndex().getValue();
    _builder.append(_value_1);
    return _builder.toString();
  }
  
  private static String _instructionCode(final ALOAD_0 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("aload_0 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final ALOAD_1 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("aload_1 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final ALOAD_2 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("aload_2 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final ALOAD_3 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("aload_3 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final ANEWARRAY it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("anewarray ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _u2Value = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(it.getIndex()));
    _builder.append(_u2Value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final ARETURN it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("areturn ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final ARRAYLENGTH it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("arraylength ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final ASTORE it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("astore ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _value_1 = it.getIndex().getValue();
    _builder.append(_value_1);
    return _builder.toString();
  }
  
  private static String _instructionCode(final ASTORE_0 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("astore_0 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final ASTORE_1 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("astore_1 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final ASTORE_2 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("astore_2 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final ASTORE_3 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("astore_3 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final ATHROW it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("athrow ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final BALOAD it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("baload ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final BASTORE it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("bastore ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final BIPUSH it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("bipush ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _value_1 = it.getByte().getValue();
    _builder.append(_value_1);
    return _builder.toString();
  }
  
  private static String _instructionCode(final CALOAD it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("caload ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final CASTORE it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("castore ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final CHECKCAST it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("checkcast ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _u2Value = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(it.getIndex()));
    _builder.append(_u2Value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final D2F it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("d2f ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final D2I it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("d2i ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final D2L it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("d2l ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final DADD it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("dadd ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final DALOAD it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("daload ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final DASTORE it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("dastore ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final DCMPG it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("dcmpg ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final DCMPL it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("dcmpl ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final DCONST_0 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("dconst_0 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final DCONST_1 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("dconst_1 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final DDIV it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("ddiv ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final DLOAD it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("dload ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _value_1 = it.getIndex().getValue();
    _builder.append(_value_1);
    return _builder.toString();
  }
  
  private static String _instructionCode(final DLOAD_0 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("dload_0 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final DLOAD_1 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("dload_1 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final DLOAD_2 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("dload_2 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final DLOAD_3 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("dload_3 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final DMUL it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("dmul ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final DNEG it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("dneg ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final DREM it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("drem ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final DRETURN it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("dreturn ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final DSTORE it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("dstore ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _value_1 = it.getIndex().getValue();
    _builder.append(_value_1);
    return _builder.toString();
  }
  
  private static String _instructionCode(final DSTORE_0 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("dstore_0 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final DSTORE_1 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("dstore_1 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final DSTORE_2 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("dstore_2 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final DSTORE_3 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("dstore_3 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final DSUB it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("dsub ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final DUP it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("dup ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final DUP_X1 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("dup_x1 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final DUP_X2 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("dup_x2 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final DUP2 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("dup2 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final DUP2_X1 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("dup2_x1 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final DUP2_X2 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("dup2_x2 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final F2D it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("f2d ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final F2I it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("f2i ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final F2L it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("f2l ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final FADD it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("fadd ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final FALOAD it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("faload ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final FASTORE it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("fastore ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final FCMPG it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("fcmpg ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final FCMPL it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("fcmpl ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final FCONST_0 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("fconst_0 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final FCONST_1 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("fconst_1 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final FCONST_2 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("fconst_2 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final FDIV it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("fdiv ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final FLOAD it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("fload ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _value_1 = it.getIndex().getValue();
    _builder.append(_value_1);
    return _builder.toString();
  }
  
  private static String _instructionCode(final FLOAD_0 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("fload_0 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final FLOAD_1 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("fload_1 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final FLOAD_2 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("fload_2 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final FLOAD_3 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("fload_3 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final FMUL it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("fmul ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final FNEG it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("fneg ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final FREM it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("frem ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final FRETURN it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("freturn ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final FSTORE it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("fstore ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _value_1 = it.getIndex().getValue();
    _builder.append(_value_1);
    return _builder.toString();
  }
  
  private static String _instructionCode(final FSTORE_0 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("fstore_0 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final FSTORE_1 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("fstore_1 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final FSTORE_2 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("fstore_2 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final FSTORE_3 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("fstore_3 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final FSUB it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("fsub ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final GETFIELD it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("getfield ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _u2Value = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(it.getIndex()));
    _builder.append(_u2Value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final GETSTATIC it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("getstatic ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _u2Value = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(it.getIndex()));
    _builder.append(_u2Value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final GOTO it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("goto ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    int _offset = ClassFileAccessAPI.offset(it.getBranch());
    int _offset_1 = ClassFileAccessAPI.offset(it);
    String _u2SignedValue = ClassFileAccessAPI.u2SignedValue((_offset - _offset_1));
    _builder.append(_u2SignedValue);
    return _builder.toString();
  }
  
  private static String _instructionCode(final GOTO_W it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("goto_w ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    int _offset = ClassFileAccessAPI.offset(it.getBranch());
    int _offset_1 = ClassFileAccessAPI.offset(it);
    String _u4SignedValue = ClassFileAccessAPI.u4SignedValue((_offset - _offset_1));
    _builder.append(_u4SignedValue);
    return _builder.toString();
  }
  
  private static String _instructionCode(final I2B it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("i2b ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final I2C it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("i2c ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final I2D it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("i2d ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final I2F it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("i2f ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final I2L it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("i2l ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final I2S it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("i2s ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final IADD it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("iadd ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final IALOAD it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("iaload ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final IAND it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("iand ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final IASTORE it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("iastore ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final ICONST_ML it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("iconst_ml ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final ICONST_0 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("iconst_0 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final ICONST_1 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("iconst_1 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final ICONST_2 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("iconst_2 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final ICONST_3 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("iconst_3 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final ICONST_4 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("iconst_4 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final ICONST_5 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("iconst_5 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final IDIV it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("idiv ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final IF_ACMPEQ it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("if_acmpeq ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    int _offset = ClassFileAccessAPI.offset(it.getBranch());
    int _offset_1 = ClassFileAccessAPI.offset(it);
    String _u2SignedValue = ClassFileAccessAPI.u2SignedValue((_offset - _offset_1));
    _builder.append(_u2SignedValue);
    return _builder.toString();
  }
  
  private static String _instructionCode(final IF_ACMPNE it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("if_acmpne ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    int _offset = ClassFileAccessAPI.offset(it.getBranch());
    int _offset_1 = ClassFileAccessAPI.offset(it);
    String _u2SignedValue = ClassFileAccessAPI.u2SignedValue((_offset - _offset_1));
    _builder.append(_u2SignedValue);
    return _builder.toString();
  }
  
  private static String _instructionCode(final IF_ICMPEQ it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("if_icmpeq ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    int _offset = ClassFileAccessAPI.offset(it.getBranch());
    int _offset_1 = ClassFileAccessAPI.offset(it);
    String _u2SignedValue = ClassFileAccessAPI.u2SignedValue((_offset - _offset_1));
    _builder.append(_u2SignedValue);
    return _builder.toString();
  }
  
  private static String _instructionCode(final IF_ICMPGE it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("if_icmpge ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    int _offset = ClassFileAccessAPI.offset(it.getBranch());
    int _offset_1 = ClassFileAccessAPI.offset(it);
    String _u2SignedValue = ClassFileAccessAPI.u2SignedValue((_offset - _offset_1));
    _builder.append(_u2SignedValue);
    return _builder.toString();
  }
  
  private static String _instructionCode(final IF_ICMPGT it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("if_icmpgt ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    int _offset = ClassFileAccessAPI.offset(it.getBranch());
    int _offset_1 = ClassFileAccessAPI.offset(it);
    String _u2SignedValue = ClassFileAccessAPI.u2SignedValue((_offset - _offset_1));
    _builder.append(_u2SignedValue);
    return _builder.toString();
  }
  
  private static String _instructionCode(final IF_ICMPLE it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("if_icmple ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    int _offset = ClassFileAccessAPI.offset(it.getBranch());
    int _offset_1 = ClassFileAccessAPI.offset(it);
    String _u2SignedValue = ClassFileAccessAPI.u2SignedValue((_offset - _offset_1));
    _builder.append(_u2SignedValue);
    return _builder.toString();
  }
  
  private static String _instructionCode(final IF_ICMPLT it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("if_icmplt ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    int _offset = ClassFileAccessAPI.offset(it.getBranch());
    int _offset_1 = ClassFileAccessAPI.offset(it);
    String _u2SignedValue = ClassFileAccessAPI.u2SignedValue((_offset - _offset_1));
    _builder.append(_u2SignedValue);
    return _builder.toString();
  }
  
  private static String _instructionCode(final IF_ICMPNE it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("if_icmpne ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    int _offset = ClassFileAccessAPI.offset(it.getBranch());
    int _offset_1 = ClassFileAccessAPI.offset(it);
    String _u2SignedValue = ClassFileAccessAPI.u2SignedValue((_offset - _offset_1));
    _builder.append(_u2SignedValue);
    return _builder.toString();
  }
  
  private static String _instructionCode(final IFEQ it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("ifeq ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    int _offset = ClassFileAccessAPI.offset(it.getBranch());
    int _offset_1 = ClassFileAccessAPI.offset(it);
    String _u2SignedValue = ClassFileAccessAPI.u2SignedValue((_offset - _offset_1));
    _builder.append(_u2SignedValue);
    return _builder.toString();
  }
  
  private static String _instructionCode(final IFNE it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("ifne ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    int _offset = ClassFileAccessAPI.offset(it.getBranch());
    int _offset_1 = ClassFileAccessAPI.offset(it);
    String _u2SignedValue = ClassFileAccessAPI.u2SignedValue((_offset - _offset_1));
    _builder.append(_u2SignedValue);
    return _builder.toString();
  }
  
  private static String _instructionCode(final IFLT it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("iflt ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    int _offset = ClassFileAccessAPI.offset(it.getBranch());
    int _offset_1 = ClassFileAccessAPI.offset(it);
    String _u2SignedValue = ClassFileAccessAPI.u2SignedValue((_offset - _offset_1));
    _builder.append(_u2SignedValue);
    return _builder.toString();
  }
  
  private static String _instructionCode(final IFGE it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("ifge ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    int _offset = ClassFileAccessAPI.offset(it.getBranch());
    int _offset_1 = ClassFileAccessAPI.offset(it);
    String _u2SignedValue = ClassFileAccessAPI.u2SignedValue((_offset - _offset_1));
    _builder.append(_u2SignedValue);
    return _builder.toString();
  }
  
  private static String _instructionCode(final IFGT it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("ifgt ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    int _offset = ClassFileAccessAPI.offset(it.getBranch());
    int _offset_1 = ClassFileAccessAPI.offset(it);
    String _u2SignedValue = ClassFileAccessAPI.u2SignedValue((_offset - _offset_1));
    _builder.append(_u2SignedValue);
    return _builder.toString();
  }
  
  private static String _instructionCode(final IFLE it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("ifle ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    int _offset = ClassFileAccessAPI.offset(it.getBranch());
    int _offset_1 = ClassFileAccessAPI.offset(it);
    String _u2SignedValue = ClassFileAccessAPI.u2SignedValue((_offset - _offset_1));
    _builder.append(_u2SignedValue);
    return _builder.toString();
  }
  
  private static String _instructionCode(final IFNONNULL it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("ifnonnull ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    int _offset = ClassFileAccessAPI.offset(it.getBranch());
    int _offset_1 = ClassFileAccessAPI.offset(it);
    String _u2SignedValue = ClassFileAccessAPI.u2SignedValue((_offset - _offset_1));
    _builder.append(_u2SignedValue);
    return _builder.toString();
  }
  
  private static String _instructionCode(final IFNULL it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("ifnull ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    int _offset = ClassFileAccessAPI.offset(it.getBranch());
    int _offset_1 = ClassFileAccessAPI.offset(it);
    String _u2SignedValue = ClassFileAccessAPI.u2SignedValue((_offset - _offset_1));
    _builder.append(_u2SignedValue);
    return _builder.toString();
  }
  
  private static String _instructionCode(final IINC it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("iinc ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _value_1 = it.getIndex().getValue();
    _builder.append(_value_1);
    _builder.append(" ");
    String _value_2 = it.getConst().getValue();
    _builder.append(_value_2);
    return _builder.toString();
  }
  
  private static String _instructionCode(final ILOAD it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("iload ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _value_1 = it.getIndex().getValue();
    _builder.append(_value_1);
    return _builder.toString();
  }
  
  private static String _instructionCode(final ILOAD_0 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("iload_0 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final ILOAD_1 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("iload_1 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final ILOAD_2 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("iload_2 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final ILOAD_3 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("iload_3 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final IMUL it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("imul ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final INEG it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("ineg ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final INSTANCEOF it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("instanceof ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _u2Value = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(it.getIndex()));
    _builder.append(_u2Value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final INVOKEDYNAMIC it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("invokedynamic ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _u2Value = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(it.getIndex()));
    _builder.append(_u2Value);
    _builder.append(" ");
    String _value_1 = it.getA0().getValue();
    _builder.append(_value_1);
    _builder.append(" ");
    String _value_2 = it.getA1().getValue();
    _builder.append(_value_2);
    return _builder.toString();
  }
  
  private static String _instructionCode(final INVOKEINTERFACE it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("invokeinterface ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _u2Value = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(it.getIndex()));
    _builder.append(_u2Value);
    _builder.append(" ");
    String _value_1 = it.getCount().getValue();
    _builder.append(_value_1);
    _builder.append(" ");
    String _value_2 = it.getA0().getValue();
    _builder.append(_value_2);
    return _builder.toString();
  }
  
  private static String _instructionCode(final INVOKESPECIAL it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("invokespecial ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _u2Value = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(it.getIndex()));
    _builder.append(_u2Value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final INVOKESTATIC it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("invokestatic ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _u2Value = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(it.getIndex()));
    _builder.append(_u2Value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final INVOKEVIRTUAL it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("invokevirtual ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _u2Value = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(it.getIndex()));
    _builder.append(_u2Value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final IOR it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("ior ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final IREM it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("irem ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final IRETURN it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("ireturn ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final ISHL it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("ishl ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final ISHR it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("ishr ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final ISTORE it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("istore ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _value_1 = it.getIndex().getValue();
    _builder.append(_value_1);
    return _builder.toString();
  }
  
  private static String _instructionCode(final ISTORE_0 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("istore_0 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final ISTORE_1 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("istore_1 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final ISTORE_2 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("istore_2 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final ISTORE_3 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("istore_3 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final ISUB it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("isub ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final IUSHR it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("iushr ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final IXOR it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("ixor ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final JSR it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("jsr ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _u2Value = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.offset(it.getBranch()));
    _builder.append(_u2Value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final JSR_W it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("jsr_w ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _u4Value = ClassFileAccessAPI.u4Value(ClassFileAccessAPI.offset(it.getBranch()));
    _builder.append(_u4Value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final L2D it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("l2d ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final L2F it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("l2f ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final L2I it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("l2i ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final LADD it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("ladd ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final LALOAD it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("laload ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final LAND it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("land ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final LASTORE it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("lastore ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final LCMP it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("lcmp ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final LCONST_0 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("lconst_0 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final LCONST_1 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("lconst_1 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final LDC it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("ldc ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _u1Value = ClassFileAccessAPI.u1Value(ClassFileAccessAPI.index(it.getIndex()));
    _builder.append(_u1Value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final LDC_W it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("ldc_w ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _u2Value = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(it.getIndex()));
    _builder.append(_u2Value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final LDC2_W it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("ldc2_w ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _u2Value = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(it.getIndex()));
    _builder.append(_u2Value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final LDIV it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("ldiv ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final LLOAD it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("lload ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _value_1 = it.getIndex().getValue();
    _builder.append(_value_1);
    return _builder.toString();
  }
  
  private static String _instructionCode(final LLOAD_0 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("lload_0 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final LLOAD_1 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("lload_1 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final LLOAD_2 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("lload_2 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final LLOAD_3 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("lload_3 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final LMUL it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("lmul ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final LNEG it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("lneg ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final LOOKUPSWITCH it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("lookupswitch ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    {
      U1 _pad0 = it.getPad0();
      boolean _tripleNotEquals = (_pad0 != null);
      if (_tripleNotEquals) {
        _builder.append(" ");
        String _value_1 = it.getPad0().getValue();
        _builder.append(_value_1);
      }
    }
    {
      U1 _pad1 = it.getPad1();
      boolean _tripleNotEquals_1 = (_pad1 != null);
      if (_tripleNotEquals_1) {
        _builder.append(" ");
        String _value_2 = it.getPad1().getValue();
        _builder.append(_value_2);
      }
    }
    {
      U1 _pad2 = it.getPad2();
      boolean _tripleNotEquals_2 = (_pad2 != null);
      if (_tripleNotEquals_2) {
        _builder.append(" ");
        String _value_3 = it.getPad2().getValue();
        _builder.append(_value_3);
      }
    }
    _builder.append(" ");
    String _value_4 = it.getDefault().getValue();
    _builder.append(_value_4);
    _builder.append(" ");
    String _value_5 = it.getNpairs().getValue();
    _builder.append(_value_5);
    StringConcatenation _builder_1 = new StringConcatenation();
    _builder_1.append(" ");
    _builder_1.append("matchOffsetPairs {");
    {
      EList<MatchOffsetPair> _matchOffsetPairs = it.getMatchOffsetPairs();
      boolean _hasElements = false;
      for(final MatchOffsetPair p : _matchOffsetPairs) {
        if (!_hasElements) {
          _hasElements = true;
        } else {
          _builder_1.appendImmediate(" ,", " ");
        }
        String _value_6 = p.getMatch().getValue();
        _builder_1.append(_value_6, " ");
        _builder_1.append(" ");
        String _value_7 = p.getOffset().getValue();
        _builder_1.append(_value_7, " ");
      }
    }
    _builder_1.append(" }");
    return (_builder.toString() + _builder_1);
  }
  
  private static String _instructionCode(final LOR it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("lor ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final LREM it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("lrem ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final LRETURN it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("lreturn ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final LSHL it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("lshl ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final LSHR it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("lshr ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final LSTORE it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("lstore ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _value_1 = it.getIndex().getValue();
    _builder.append(_value_1);
    return _builder.toString();
  }
  
  private static String _instructionCode(final LSTORE_0 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("lstore_0 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final LSTORE_1 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("lstore_1 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final LSTORE_2 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("lstore_2 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final LSTORE_3 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("lstore_3 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final LSUB it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("lsub ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final LUSHR it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("lushr ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final LXOR it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("lxor ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final MONITORENTER it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("monitorenter ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final MONITOREXIT it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("monitorexit ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final MULTIANEWARRAY it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("multianewarray ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _u2Value = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(it.getIndex()));
    _builder.append(_u2Value);
    _builder.append(" ");
    String _value_1 = it.getDimensions().getValue();
    _builder.append(_value_1);
    return _builder.toString();
  }
  
  private static String _instructionCode(final NEW it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("new ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _u2Value = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(it.getIndex()));
    _builder.append(_u2Value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final NEWARRAY it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("newarray ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _value_1 = it.getAtype().getValue();
    _builder.append(_value_1);
    return _builder.toString();
  }
  
  private static String _instructionCode(final NOP it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("nop ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final POP it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("pop ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final POP2 it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("pop2 ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final PUTFIELD it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("putfield ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _u2Value = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(it.getIndex()));
    _builder.append(_u2Value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final PUTSTATIC it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("putstatic ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _u2Value = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(it.getIndex()));
    _builder.append(_u2Value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final RET it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("ret ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _value_1 = it.getIndex().getValue();
    _builder.append(_value_1);
    return _builder.toString();
  }
  
  private static String _instructionCode(final RETURN it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("return ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final SALOAD it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("saload ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final SASTORE it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("sastore ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final SIPUSH it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("sipush ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _value_1 = it.getValue().getValue();
    _builder.append(_value_1);
    return _builder.toString();
  }
  
  private static String _instructionCode(final SWAP it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("swap ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    return _builder.toString();
  }
  
  private static String _instructionCode(final TABLESWITCH it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("tableswitch ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    {
      U1 _pad0 = it.getPad0();
      boolean _tripleNotEquals = (_pad0 != null);
      if (_tripleNotEquals) {
        _builder.append(" ");
        String _value_1 = it.getPad0().getValue();
        _builder.append(_value_1);
      }
    }
    {
      U1 _pad1 = it.getPad1();
      boolean _tripleNotEquals_1 = (_pad1 != null);
      if (_tripleNotEquals_1) {
        _builder.append(" ");
        String _value_2 = it.getPad1().getValue();
        _builder.append(_value_2);
      }
    }
    {
      U1 _pad2 = it.getPad2();
      boolean _tripleNotEquals_2 = (_pad2 != null);
      if (_tripleNotEquals_2) {
        _builder.append(" ");
        String _value_3 = it.getPad2().getValue();
        _builder.append(_value_3);
      }
    }
    _builder.append(" ");
    String _value_4 = it.getDefault().getValue();
    _builder.append(_value_4);
    _builder.append(" ");
    String _value_5 = it.getLow().getValue();
    _builder.append(_value_5);
    _builder.append(" ");
    String _value_6 = it.getHigh().getValue();
    _builder.append(_value_6);
    StringConcatenation _builder_1 = new StringConcatenation();
    _builder_1.append(" ");
    _builder_1.append("jumpOffsets {");
    {
      EList<JumpOffset> _jumpOffsets = it.getJumpOffsets();
      boolean _hasElements = false;
      for(final JumpOffset p : _jumpOffsets) {
        if (!_hasElements) {
          _hasElements = true;
        } else {
          _builder_1.appendImmediate(" ", " ");
        }
        String _value_7 = p.getOffset().getValue();
        _builder_1.append(_value_7, " ");
      }
    }
    _builder_1.append(" ");
    String _plus = (_builder.toString() + _builder_1);
    StringConcatenation _builder_2 = new StringConcatenation();
    _builder_2.append("}");
    return (_plus + _builder_2);
  }
  
  private static String _instructionCode(final WIDE it) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("wide ");
    String _value = it.getTag().getValue();
    _builder.append(_value);
    _builder.append(" ");
    String _value_1 = it.getOpcode().getValue();
    _builder.append(_value_1);
    _builder.append(" ");
    String _value_2 = it.getIndex().getValue();
    _builder.append(_value_2);
    _builder.append(" ");
    {
      U2 _const = it.getConst();
      boolean _tripleNotEquals = (_const != null);
      if (_tripleNotEquals) {
        _builder.append(" ");
        String _value_3 = it.getConst().getValue();
        _builder.append(_value_3);
      }
    }
    return _builder.toString();
  }
  
  private static String code(final ExceptionTable exceptionTable) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("ExceptionTable {");
    _builder.newLine();
    {
      EList<ExceptionTableEntry> _exceptionTableEntry = exceptionTable.getExceptionTableEntry();
      for(final ExceptionTableEntry entry : _exceptionTableEntry) {
        _builder.append("\t");
        _builder.append("entry ");
        String _u2Value = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.offset(entry.getStartPc()));
        _builder.append(_u2Value, "\t");
        _builder.append(" ");
        String _u2Value_1 = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.offset(entry.getEndPc()));
        _builder.append(_u2Value_1, "\t");
        _builder.append(" ");
        String _u2Value_2 = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.offset(entry.getHandlerPc()));
        _builder.append(_u2Value_2, "\t");
        _builder.append(" ");
        String _u2Value_3 = ClassFileAccessAPI.u2Value(ClassFileAccessAPI.index(entry.getCatchType()));
        _builder.append(_u2Value_3, "\t");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.append("}");
    return _builder.toString();
  }
  
  private static String code(final EList<U1> bytes) {
    StringConcatenation _builder = new StringConcatenation();
    {
      for(final U1 b : bytes) {
        String _value = b.getValue();
        _builder.append(_value);
        _builder.append(" ");
      }
    }
    return _builder.toString();
  }
  
  public static String constantCode(final ConstantPoolEntry constant) {
    if (constant instanceof ConstantClass) {
      return _constantCode((ConstantClass)constant);
    } else if (constant instanceof ConstantDouble) {
      return _constantCode((ConstantDouble)constant);
    } else if (constant instanceof ConstantFieldRef) {
      return _constantCode((ConstantFieldRef)constant);
    } else if (constant instanceof ConstantFloat) {
      return _constantCode((ConstantFloat)constant);
    } else if (constant instanceof ConstantInteger) {
      return _constantCode((ConstantInteger)constant);
    } else if (constant instanceof ConstantInterfaceMethodRef) {
      return _constantCode((ConstantInterfaceMethodRef)constant);
    } else if (constant instanceof ConstantInvoceDynamic) {
      return _constantCode((ConstantInvoceDynamic)constant);
    } else if (constant instanceof ConstantLong) {
      return _constantCode((ConstantLong)constant);
    } else if (constant instanceof ConstantMethodHandle) {
      return _constantCode((ConstantMethodHandle)constant);
    } else if (constant instanceof ConstantMethodRef) {
      return _constantCode((ConstantMethodRef)constant);
    } else if (constant instanceof ConstantMethodType) {
      return _constantCode((ConstantMethodType)constant);
    } else if (constant instanceof ConstantModule) {
      return _constantCode((ConstantModule)constant);
    } else if (constant instanceof ConstantNameAndType) {
      return _constantCode((ConstantNameAndType)constant);
    } else if (constant instanceof ConstantPackage) {
      return _constantCode((ConstantPackage)constant);
    } else if (constant instanceof ConstantString) {
      return _constantCode((ConstantString)constant);
    } else if (constant instanceof ConstantUtf8) {
      return _constantCode((ConstantUtf8)constant);
    } else {
      throw new IllegalArgumentException("Unhandled parameter types: " +
        Arrays.<Object>asList(constant).toString());
    }
  }
  
  public static String attributeCode(final AttributeInfo attribute) {
    if (attribute instanceof Code) {
      return _attributeCode((Code)attribute);
    } else if (attribute instanceof ConstantValue) {
      return _attributeCode((ConstantValue)attribute);
    } else if (attribute instanceof EnclosingMethod) {
      return _attributeCode((EnclosingMethod)attribute);
    } else if (attribute instanceof Exceptions) {
      return _attributeCode((Exceptions)attribute);
    } else if (attribute instanceof InnerClasses) {
      return _attributeCode((InnerClasses)attribute);
    } else if (attribute instanceof LineNumberTable) {
      return _attributeCode((LineNumberTable)attribute);
    } else if (attribute instanceof LocalVariableTable) {
      return _attributeCode((LocalVariableTable)attribute);
    } else if (attribute instanceof Module) {
      return _attributeCode((Module)attribute);
    } else if (attribute instanceof SourceFile) {
      return _attributeCode((SourceFile)attribute);
    } else if (attribute instanceof Unknown) {
      return _attributeCode((Unknown)attribute);
    } else {
      throw new IllegalArgumentException("Unhandled parameter types: " +
        Arrays.<Object>asList(attribute).toString());
    }
  }
  
  private static String instructionCode(final CodeTableEntry it) {
    if (it instanceof AALOAD) {
      return _instructionCode((AALOAD)it);
    } else if (it instanceof AASTORE) {
      return _instructionCode((AASTORE)it);
    } else if (it instanceof ACONST_NULL) {
      return _instructionCode((ACONST_NULL)it);
    } else if (it instanceof ALOAD) {
      return _instructionCode((ALOAD)it);
    } else if (it instanceof ALOAD_0) {
      return _instructionCode((ALOAD_0)it);
    } else if (it instanceof ALOAD_1) {
      return _instructionCode((ALOAD_1)it);
    } else if (it instanceof ALOAD_2) {
      return _instructionCode((ALOAD_2)it);
    } else if (it instanceof ALOAD_3) {
      return _instructionCode((ALOAD_3)it);
    } else if (it instanceof ANEWARRAY) {
      return _instructionCode((ANEWARRAY)it);
    } else if (it instanceof ARETURN) {
      return _instructionCode((ARETURN)it);
    } else if (it instanceof ARRAYLENGTH) {
      return _instructionCode((ARRAYLENGTH)it);
    } else if (it instanceof ASTORE) {
      return _instructionCode((ASTORE)it);
    } else if (it instanceof ASTORE_0) {
      return _instructionCode((ASTORE_0)it);
    } else if (it instanceof ASTORE_1) {
      return _instructionCode((ASTORE_1)it);
    } else if (it instanceof ASTORE_2) {
      return _instructionCode((ASTORE_2)it);
    } else if (it instanceof ASTORE_3) {
      return _instructionCode((ASTORE_3)it);
    } else if (it instanceof ATHROW) {
      return _instructionCode((ATHROW)it);
    } else if (it instanceof BALOAD) {
      return _instructionCode((BALOAD)it);
    } else if (it instanceof BASTORE) {
      return _instructionCode((BASTORE)it);
    } else if (it instanceof BIPUSH) {
      return _instructionCode((BIPUSH)it);
    } else if (it instanceof CALOAD) {
      return _instructionCode((CALOAD)it);
    } else if (it instanceof CASTORE) {
      return _instructionCode((CASTORE)it);
    } else if (it instanceof CHECKCAST) {
      return _instructionCode((CHECKCAST)it);
    } else if (it instanceof D2F) {
      return _instructionCode((D2F)it);
    } else if (it instanceof D2I) {
      return _instructionCode((D2I)it);
    } else if (it instanceof D2L) {
      return _instructionCode((D2L)it);
    } else if (it instanceof DADD) {
      return _instructionCode((DADD)it);
    } else if (it instanceof DALOAD) {
      return _instructionCode((DALOAD)it);
    } else if (it instanceof DASTORE) {
      return _instructionCode((DASTORE)it);
    } else if (it instanceof DCMPG) {
      return _instructionCode((DCMPG)it);
    } else if (it instanceof DCMPL) {
      return _instructionCode((DCMPL)it);
    } else if (it instanceof DCONST_0) {
      return _instructionCode((DCONST_0)it);
    } else if (it instanceof DCONST_1) {
      return _instructionCode((DCONST_1)it);
    } else if (it instanceof DDIV) {
      return _instructionCode((DDIV)it);
    } else if (it instanceof DLOAD) {
      return _instructionCode((DLOAD)it);
    } else if (it instanceof DLOAD_0) {
      return _instructionCode((DLOAD_0)it);
    } else if (it instanceof DLOAD_1) {
      return _instructionCode((DLOAD_1)it);
    } else if (it instanceof DLOAD_2) {
      return _instructionCode((DLOAD_2)it);
    } else if (it instanceof DLOAD_3) {
      return _instructionCode((DLOAD_3)it);
    } else if (it instanceof DMUL) {
      return _instructionCode((DMUL)it);
    } else if (it instanceof DNEG) {
      return _instructionCode((DNEG)it);
    } else if (it instanceof DREM) {
      return _instructionCode((DREM)it);
    } else if (it instanceof DRETURN) {
      return _instructionCode((DRETURN)it);
    } else if (it instanceof DSTORE) {
      return _instructionCode((DSTORE)it);
    } else if (it instanceof DSTORE_0) {
      return _instructionCode((DSTORE_0)it);
    } else if (it instanceof DSTORE_1) {
      return _instructionCode((DSTORE_1)it);
    } else if (it instanceof DSTORE_2) {
      return _instructionCode((DSTORE_2)it);
    } else if (it instanceof DSTORE_3) {
      return _instructionCode((DSTORE_3)it);
    } else if (it instanceof DSUB) {
      return _instructionCode((DSUB)it);
    } else if (it instanceof DUP) {
      return _instructionCode((DUP)it);
    } else if (it instanceof DUP2) {
      return _instructionCode((DUP2)it);
    } else if (it instanceof DUP2_X1) {
      return _instructionCode((DUP2_X1)it);
    } else if (it instanceof DUP2_X2) {
      return _instructionCode((DUP2_X2)it);
    } else if (it instanceof DUP_X1) {
      return _instructionCode((DUP_X1)it);
    } else if (it instanceof DUP_X2) {
      return _instructionCode((DUP_X2)it);
    } else if (it instanceof F2D) {
      return _instructionCode((F2D)it);
    } else if (it instanceof F2I) {
      return _instructionCode((F2I)it);
    } else if (it instanceof F2L) {
      return _instructionCode((F2L)it);
    } else if (it instanceof FADD) {
      return _instructionCode((FADD)it);
    } else if (it instanceof FALOAD) {
      return _instructionCode((FALOAD)it);
    } else if (it instanceof FASTORE) {
      return _instructionCode((FASTORE)it);
    } else if (it instanceof FCMPG) {
      return _instructionCode((FCMPG)it);
    } else if (it instanceof FCMPL) {
      return _instructionCode((FCMPL)it);
    } else if (it instanceof FCONST_0) {
      return _instructionCode((FCONST_0)it);
    } else if (it instanceof FCONST_1) {
      return _instructionCode((FCONST_1)it);
    } else if (it instanceof FCONST_2) {
      return _instructionCode((FCONST_2)it);
    } else if (it instanceof FDIV) {
      return _instructionCode((FDIV)it);
    } else if (it instanceof FLOAD) {
      return _instructionCode((FLOAD)it);
    } else if (it instanceof FLOAD_0) {
      return _instructionCode((FLOAD_0)it);
    } else if (it instanceof FLOAD_1) {
      return _instructionCode((FLOAD_1)it);
    } else if (it instanceof FLOAD_2) {
      return _instructionCode((FLOAD_2)it);
    } else if (it instanceof FLOAD_3) {
      return _instructionCode((FLOAD_3)it);
    } else if (it instanceof FMUL) {
      return _instructionCode((FMUL)it);
    } else if (it instanceof FNEG) {
      return _instructionCode((FNEG)it);
    } else if (it instanceof FREM) {
      return _instructionCode((FREM)it);
    } else if (it instanceof FRETURN) {
      return _instructionCode((FRETURN)it);
    } else if (it instanceof FSTORE) {
      return _instructionCode((FSTORE)it);
    } else if (it instanceof FSTORE_0) {
      return _instructionCode((FSTORE_0)it);
    } else if (it instanceof FSTORE_1) {
      return _instructionCode((FSTORE_1)it);
    } else if (it instanceof FSTORE_2) {
      return _instructionCode((FSTORE_2)it);
    } else if (it instanceof FSTORE_3) {
      return _instructionCode((FSTORE_3)it);
    } else if (it instanceof FSUB) {
      return _instructionCode((FSUB)it);
    } else if (it instanceof GETFIELD) {
      return _instructionCode((GETFIELD)it);
    } else if (it instanceof GETSTATIC) {
      return _instructionCode((GETSTATIC)it);
    } else if (it instanceof GOTO) {
      return _instructionCode((GOTO)it);
    } else if (it instanceof GOTO_W) {
      return _instructionCode((GOTO_W)it);
    } else if (it instanceof I2B) {
      return _instructionCode((I2B)it);
    } else if (it instanceof I2C) {
      return _instructionCode((I2C)it);
    } else if (it instanceof I2D) {
      return _instructionCode((I2D)it);
    } else if (it instanceof I2F) {
      return _instructionCode((I2F)it);
    } else if (it instanceof I2L) {
      return _instructionCode((I2L)it);
    } else if (it instanceof I2S) {
      return _instructionCode((I2S)it);
    } else if (it instanceof IADD) {
      return _instructionCode((IADD)it);
    } else if (it instanceof IALOAD) {
      return _instructionCode((IALOAD)it);
    } else if (it instanceof IAND) {
      return _instructionCode((IAND)it);
    } else if (it instanceof IASTORE) {
      return _instructionCode((IASTORE)it);
    } else if (it instanceof ICONST_0) {
      return _instructionCode((ICONST_0)it);
    } else if (it instanceof ICONST_1) {
      return _instructionCode((ICONST_1)it);
    } else if (it instanceof ICONST_2) {
      return _instructionCode((ICONST_2)it);
    } else if (it instanceof ICONST_3) {
      return _instructionCode((ICONST_3)it);
    } else if (it instanceof ICONST_4) {
      return _instructionCode((ICONST_4)it);
    } else if (it instanceof ICONST_5) {
      return _instructionCode((ICONST_5)it);
    } else if (it instanceof ICONST_ML) {
      return _instructionCode((ICONST_ML)it);
    } else if (it instanceof IDIV) {
      return _instructionCode((IDIV)it);
    } else if (it instanceof IFEQ) {
      return _instructionCode((IFEQ)it);
    } else if (it instanceof IFGE) {
      return _instructionCode((IFGE)it);
    } else if (it instanceof IFGT) {
      return _instructionCode((IFGT)it);
    } else if (it instanceof IFLE) {
      return _instructionCode((IFLE)it);
    } else if (it instanceof IFLT) {
      return _instructionCode((IFLT)it);
    } else if (it instanceof IFNE) {
      return _instructionCode((IFNE)it);
    } else if (it instanceof IFNONNULL) {
      return _instructionCode((IFNONNULL)it);
    } else if (it instanceof IFNULL) {
      return _instructionCode((IFNULL)it);
    } else if (it instanceof IF_ACMPEQ) {
      return _instructionCode((IF_ACMPEQ)it);
    } else if (it instanceof IF_ACMPNE) {
      return _instructionCode((IF_ACMPNE)it);
    } else if (it instanceof IF_ICMPEQ) {
      return _instructionCode((IF_ICMPEQ)it);
    } else if (it instanceof IF_ICMPGE) {
      return _instructionCode((IF_ICMPGE)it);
    } else if (it instanceof IF_ICMPGT) {
      return _instructionCode((IF_ICMPGT)it);
    } else if (it instanceof IF_ICMPLE) {
      return _instructionCode((IF_ICMPLE)it);
    } else if (it instanceof IF_ICMPLT) {
      return _instructionCode((IF_ICMPLT)it);
    } else if (it instanceof IF_ICMPNE) {
      return _instructionCode((IF_ICMPNE)it);
    } else if (it instanceof IINC) {
      return _instructionCode((IINC)it);
    } else if (it instanceof ILOAD) {
      return _instructionCode((ILOAD)it);
    } else if (it instanceof ILOAD_0) {
      return _instructionCode((ILOAD_0)it);
    } else if (it instanceof ILOAD_1) {
      return _instructionCode((ILOAD_1)it);
    } else if (it instanceof ILOAD_2) {
      return _instructionCode((ILOAD_2)it);
    } else if (it instanceof ILOAD_3) {
      return _instructionCode((ILOAD_3)it);
    } else if (it instanceof IMUL) {
      return _instructionCode((IMUL)it);
    } else if (it instanceof INEG) {
      return _instructionCode((INEG)it);
    } else if (it instanceof INSTANCEOF) {
      return _instructionCode((INSTANCEOF)it);
    } else if (it instanceof INVOKEDYNAMIC) {
      return _instructionCode((INVOKEDYNAMIC)it);
    } else if (it instanceof INVOKEINTERFACE) {
      return _instructionCode((INVOKEINTERFACE)it);
    } else if (it instanceof INVOKESPECIAL) {
      return _instructionCode((INVOKESPECIAL)it);
    } else if (it instanceof INVOKESTATIC) {
      return _instructionCode((INVOKESTATIC)it);
    } else if (it instanceof INVOKEVIRTUAL) {
      return _instructionCode((INVOKEVIRTUAL)it);
    } else if (it instanceof IOR) {
      return _instructionCode((IOR)it);
    } else if (it instanceof IREM) {
      return _instructionCode((IREM)it);
    } else if (it instanceof IRETURN) {
      return _instructionCode((IRETURN)it);
    } else if (it instanceof ISHL) {
      return _instructionCode((ISHL)it);
    } else if (it instanceof ISHR) {
      return _instructionCode((ISHR)it);
    } else if (it instanceof ISTORE) {
      return _instructionCode((ISTORE)it);
    } else if (it instanceof ISTORE_0) {
      return _instructionCode((ISTORE_0)it);
    } else if (it instanceof ISTORE_1) {
      return _instructionCode((ISTORE_1)it);
    } else if (it instanceof ISTORE_2) {
      return _instructionCode((ISTORE_2)it);
    } else if (it instanceof ISTORE_3) {
      return _instructionCode((ISTORE_3)it);
    } else if (it instanceof ISUB) {
      return _instructionCode((ISUB)it);
    } else if (it instanceof IUSHR) {
      return _instructionCode((IUSHR)it);
    } else if (it instanceof IXOR) {
      return _instructionCode((IXOR)it);
    } else if (it instanceof JSR) {
      return _instructionCode((JSR)it);
    } else if (it instanceof JSR_W) {
      return _instructionCode((JSR_W)it);
    } else if (it instanceof L2D) {
      return _instructionCode((L2D)it);
    } else if (it instanceof L2F) {
      return _instructionCode((L2F)it);
    } else if (it instanceof L2I) {
      return _instructionCode((L2I)it);
    } else if (it instanceof LADD) {
      return _instructionCode((LADD)it);
    } else if (it instanceof LALOAD) {
      return _instructionCode((LALOAD)it);
    } else if (it instanceof LAND) {
      return _instructionCode((LAND)it);
    } else if (it instanceof LASTORE) {
      return _instructionCode((LASTORE)it);
    } else if (it instanceof LCMP) {
      return _instructionCode((LCMP)it);
    } else if (it instanceof LCONST_0) {
      return _instructionCode((LCONST_0)it);
    } else if (it instanceof LCONST_1) {
      return _instructionCode((LCONST_1)it);
    } else if (it instanceof LDC) {
      return _instructionCode((LDC)it);
    } else if (it instanceof LDC2_W) {
      return _instructionCode((LDC2_W)it);
    } else if (it instanceof LDC_W) {
      return _instructionCode((LDC_W)it);
    } else if (it instanceof LDIV) {
      return _instructionCode((LDIV)it);
    } else if (it instanceof LLOAD) {
      return _instructionCode((LLOAD)it);
    } else if (it instanceof LLOAD_0) {
      return _instructionCode((LLOAD_0)it);
    } else if (it instanceof LLOAD_1) {
      return _instructionCode((LLOAD_1)it);
    } else if (it instanceof LLOAD_2) {
      return _instructionCode((LLOAD_2)it);
    } else if (it instanceof LLOAD_3) {
      return _instructionCode((LLOAD_3)it);
    } else if (it instanceof LMUL) {
      return _instructionCode((LMUL)it);
    } else if (it instanceof LNEG) {
      return _instructionCode((LNEG)it);
    } else if (it instanceof LOOKUPSWITCH) {
      return _instructionCode((LOOKUPSWITCH)it);
    } else if (it instanceof LOR) {
      return _instructionCode((LOR)it);
    } else if (it instanceof LREM) {
      return _instructionCode((LREM)it);
    } else if (it instanceof LRETURN) {
      return _instructionCode((LRETURN)it);
    } else if (it instanceof LSHL) {
      return _instructionCode((LSHL)it);
    } else if (it instanceof LSHR) {
      return _instructionCode((LSHR)it);
    } else if (it instanceof LSTORE) {
      return _instructionCode((LSTORE)it);
    } else if (it instanceof LSTORE_0) {
      return _instructionCode((LSTORE_0)it);
    } else if (it instanceof LSTORE_1) {
      return _instructionCode((LSTORE_1)it);
    } else if (it instanceof LSTORE_2) {
      return _instructionCode((LSTORE_2)it);
    } else if (it instanceof LSTORE_3) {
      return _instructionCode((LSTORE_3)it);
    } else if (it instanceof LSUB) {
      return _instructionCode((LSUB)it);
    } else if (it instanceof LUSHR) {
      return _instructionCode((LUSHR)it);
    } else if (it instanceof LXOR) {
      return _instructionCode((LXOR)it);
    } else if (it instanceof MONITORENTER) {
      return _instructionCode((MONITORENTER)it);
    } else if (it instanceof MONITOREXIT) {
      return _instructionCode((MONITOREXIT)it);
    } else if (it instanceof MULTIANEWARRAY) {
      return _instructionCode((MULTIANEWARRAY)it);
    } else if (it instanceof NEW) {
      return _instructionCode((NEW)it);
    } else if (it instanceof NEWARRAY) {
      return _instructionCode((NEWARRAY)it);
    } else if (it instanceof NOP) {
      return _instructionCode((NOP)it);
    } else if (it instanceof POP) {
      return _instructionCode((POP)it);
    } else if (it instanceof POP2) {
      return _instructionCode((POP2)it);
    } else if (it instanceof PUTFIELD) {
      return _instructionCode((PUTFIELD)it);
    } else if (it instanceof PUTSTATIC) {
      return _instructionCode((PUTSTATIC)it);
    } else if (it instanceof RET) {
      return _instructionCode((RET)it);
    } else if (it instanceof RETURN) {
      return _instructionCode((RETURN)it);
    } else if (it instanceof SALOAD) {
      return _instructionCode((SALOAD)it);
    } else if (it instanceof SASTORE) {
      return _instructionCode((SASTORE)it);
    } else if (it instanceof SIPUSH) {
      return _instructionCode((SIPUSH)it);
    } else if (it instanceof SWAP) {
      return _instructionCode((SWAP)it);
    } else if (it instanceof TABLESWITCH) {
      return _instructionCode((TABLESWITCH)it);
    } else if (it instanceof WIDE) {
      return _instructionCode((WIDE)it);
    } else {
      throw new IllegalArgumentException("Unhandled parameter types: " +
        Arrays.<Object>asList(it).toString());
    }
  }
}
