/**
 * generated by Xtext 2.11.0
 */
package com.itemis.jbc.scoping;

import com.google.inject.Inject;
import com.itemis.jbc.binary.ClassFileAccessAPI;
import com.itemis.jbc.jbc.Code;
import com.itemis.jbc.jbc.CodeTable;
import com.itemis.jbc.jbc.CodeTableEntry;
import com.itemis.jbc.jbc.ConstantPoolEntry;
import com.itemis.jbc.jbc.GOTO;
import com.itemis.jbc.jbc.GOTO_W;
import com.itemis.jbc.jbc.IFEQ;
import com.itemis.jbc.jbc.IFGE;
import com.itemis.jbc.jbc.IFGT;
import com.itemis.jbc.jbc.IFLE;
import com.itemis.jbc.jbc.IFLT;
import com.itemis.jbc.jbc.IFNE;
import com.itemis.jbc.jbc.IFNONNULL;
import com.itemis.jbc.jbc.IFNULL;
import com.itemis.jbc.jbc.IF_ACMPEQ;
import com.itemis.jbc.jbc.IF_ACMPNE;
import com.itemis.jbc.jbc.IF_ICMPEQ;
import com.itemis.jbc.jbc.IF_ICMPGE;
import com.itemis.jbc.jbc.IF_ICMPGT;
import com.itemis.jbc.jbc.IF_ICMPLE;
import com.itemis.jbc.jbc.IF_ICMPLT;
import com.itemis.jbc.jbc.IF_ICMPNE;
import com.itemis.jbc.jbc.JSR;
import com.itemis.jbc.jbc.JSR_W;
import com.itemis.jbc.jbc.JbcPackage;
import com.itemis.jbc.jbc.LDC;
import com.itemis.jbc.scoping.AbstractJBCScopeProvider;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.xtext.naming.IQualifiedNameProvider;
import org.eclipse.xtext.naming.QualifiedName;
import org.eclipse.xtext.resource.EObjectDescription;
import org.eclipse.xtext.resource.IEObjectDescription;
import org.eclipse.xtext.scoping.IScope;
import org.eclipse.xtext.scoping.impl.AbstractScope;
import org.eclipse.xtext.xbase.lib.Functions.Function1;
import org.eclipse.xtext.xbase.lib.IterableExtensions;
import org.eclipse.xtext.xbase.lib.ListExtensions;

/**
 * This class contains custom scoping description.
 * 
 * See https://www.eclipse.org/Xtext/documentation/303_runtime_concepts.html#scoping
 * on how and when to use it.
 */
@SuppressWarnings("all")
public class JBCScopeProvider extends AbstractJBCScopeProvider {
  @Inject
  private IQualifiedNameProvider nameProvider;
  
  @Override
  public IScope getScope(final EObject context, final EReference reference) {
    boolean _isSuperTypeOf = JbcPackage.eINSTANCE.getConstantPoolEntry().isSuperTypeOf(reference.getEReferenceType());
    if (_isSuperTypeOf) {
      if ((context instanceof LDC)) {
        return new AbstractScope(IScope.NULLSCOPE, false) {
          @Override
          protected Iterable<IEObjectDescription> getAllLocalElements() {
            final Function1<ConstantPoolEntry, Boolean> _function = (ConstantPoolEntry it) -> {
              int _index = ClassFileAccessAPI.index(it);
              return Boolean.valueOf((_index <= 0xFF));
            };
            final Function1<ConstantPoolEntry, IEObjectDescription> _function_1 = (ConstantPoolEntry it) -> {
              return EObjectDescription.create(JBCScopeProvider.this.nameProvider.getFullyQualifiedName(it), it);
            };
            return IterableExtensions.<ConstantPoolEntry, IEObjectDescription>map(IterableExtensions.<ConstantPoolEntry>filter(ClassFileAccessAPI.getClassFile(context).getConstantPool().getCpInfo(), _function), _function_1);
          }
          
          @Override
          protected Iterable<IEObjectDescription> getLocalElementsByName(final QualifiedName name) {
            String _string = name.toString();
            String _plus = ("00" + _string);
            return super.getLocalElementsByName(QualifiedName.create(_plus));
          }
        };
      }
      return new AbstractScope(IScope.NULLSCOPE, false) {
        @Override
        protected Iterable<IEObjectDescription> getAllLocalElements() {
          final Function1<ConstantPoolEntry, IEObjectDescription> _function = (ConstantPoolEntry it) -> {
            return EObjectDescription.create(JBCScopeProvider.this.nameProvider.getFullyQualifiedName(it), it);
          };
          return ListExtensions.<ConstantPoolEntry, IEObjectDescription>map(ClassFileAccessAPI.getClassFile(context).getConstantPool().getCpInfo(), _function);
        }
      };
    } else {
      boolean _isSuperTypeOf_1 = JbcPackage.eINSTANCE.getCodeTableEntry().isSuperTypeOf(reference.getEReferenceType());
      if (_isSuperTypeOf_1) {
        if (((((((((((((((((((((context instanceof GOTO) || (context instanceof GOTO_W)) || (context instanceof IF_ACMPEQ)) || 
          (context instanceof IF_ACMPNE)) || (context instanceof IF_ICMPEQ)) || (context instanceof IF_ICMPNE)) || 
          (context instanceof IF_ICMPLT)) || (context instanceof IF_ICMPGE)) || (context instanceof IF_ICMPGT)) || 
          (context instanceof IF_ICMPLE)) || (context instanceof IFEQ)) || (context instanceof IFNE)) || 
          (context instanceof IFLT)) || (context instanceof IFGE)) || (context instanceof IFGT)) || 
          (context instanceof IFLE)) || (context instanceof IFNONNULL)) || (context instanceof IFNULL)) || 
          (context instanceof JSR)) || (context instanceof JSR_W))) {
          return new AbstractScope(IScope.NULLSCOPE, false) {
            @Override
            protected Iterable<IEObjectDescription> getAllLocalElements() {
              final Function1<CodeTableEntry, IEObjectDescription> _function = (CodeTableEntry it) -> {
                return EObjectDescription.create(JBCScopeProvider.this.nameProvider.getFullyQualifiedName(it), it);
              };
              return ListExtensions.<CodeTableEntry, IEObjectDescription>map(ClassFileAccessAPI.getTable(((CodeTableEntry) context)).getInstruction(), _function);
            }
            
            @Override
            protected Iterable<IEObjectDescription> getLocalElementsByName(final QualifiedName name) {
              Iterable<IEObjectDescription> _xblockexpression = null;
              {
                final int gotoOffset = ClassFileAccessAPI.offset(((CodeTableEntry) context));
                int relativeOffset = Integer.parseInt(name.toString(), 16);
                if ((relativeOffset > Short.MAX_VALUE)) {
                  relativeOffset = ((-relativeOffset) + Short.MAX_VALUE);
                }
                _xblockexpression = super.getLocalElementsByName(QualifiedName.create(ClassFileAccessAPI.u2Value((gotoOffset + relativeOffset))));
              }
              return _xblockexpression;
            }
          };
        } else {
          if ((context instanceof CodeTable)) {
            return new AbstractScope(IScope.NULLSCOPE, false) {
              @Override
              protected Iterable<IEObjectDescription> getAllLocalElements() {
                final Function1<CodeTableEntry, IEObjectDescription> _function = (CodeTableEntry it) -> {
                  return EObjectDescription.create(JBCScopeProvider.this.nameProvider.getFullyQualifiedName(it), it);
                };
                return ListExtensions.<CodeTableEntry, IEObjectDescription>map(((CodeTable)context).getInstruction(), _function);
              }
            };
          } else {
            if ((context instanceof Code)) {
              return this.getScope(((Code)context).getCodeTable(), reference);
            }
          }
        }
      }
    }
    return this.getScope(context.eContainer(), reference);
  }
}
